Index: /trunk/src/sys/opencrypto/cryptosoft.c
===================================================================
--- /trunk/src/sys/opencrypto/cryptosoft.c	(revision 151)
+++ /trunk/src/sys/opencrypto/cryptosoft.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cryptosoft.c,v 1.20 2008/02/04 00:35:34 tls Exp $ */
+/*	$NetBSD: cryptosoft.c,v 1.20.26.1 2011/05/20 08:11:32 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/cryptosoft.c,v 1.2.2.1 2002/11/21 23:34:23 sam Exp $	*/
 /*	$OpenBSD: cryptosoft.c,v 1.35 2002/04/26 08:43:50 deraadt Exp $	*/
@@ -25,5 +25,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: cryptosoft.c,v 1.20 2008/02/04 00:35:34 tls Exp $");
+__KERNEL_RCSID(0, "$NetBSD: cryptosoft.c,v 1.20.26.1 2011/05/20 08:11:32 matt Exp $");
 
 #include <sys/param.h>
@@ -561,23 +561,6 @@
 			adj = result - crd->crd_len;
 			m_adj((struct mbuf *)buf, adj);
-		} else {
-			struct uio *uio = (struct uio *)buf;
-			int ind;
-
-			adj = crd->crd_len - result;
-			ind = uio->uio_iovcnt - 1;
-
-			while (adj > 0 && ind >= 0) {
-				if (adj < uio->uio_iov[ind].iov_len) {
-					uio->uio_iov[ind].iov_len -= adj;
-					break;
-				}
-
-				adj -= uio->uio_iov[ind].iov_len;
-				uio->uio_iov[ind].iov_len = 0;
-				ind--;
-				uio->uio_iovcnt--;
-			}
-		}
+		}
+		/* Don't adjust the iov_len, it breaks the kmem_free */
 	}
 	FREE(out, M_CRYPTO_DATA);
@@ -805,4 +788,9 @@
 			(*swd)->sw_cxf = cxf;
 			break;
+
+		case CRYPTO_GZIP_COMP:
+			cxf = &swcr_comp_algo_gzip;
+			(*swd)->sw_cxf = cxf;
+			break;
 		default:
 			swcr_freesession(NULL, i);
@@ -897,4 +885,5 @@
 
 		case CRYPTO_DEFLATE_COMP:
+		case CRYPTO_GZIP_COMP:
 			cxf = swd->sw_cxf;
 			break;
@@ -995,4 +984,6 @@
 
 		case CRYPTO_DEFLATE_COMP:
+		case CRYPTO_GZIP_COMP:
+			DPRINTF(("swcr_process: compdec for %d\n", sw->sw_alg));
 			if ((crp->crp_etype = swcr_compdec(crd, sw,
 			    crp->crp_buf, type)) != 0)
@@ -1048,4 +1039,5 @@
 	REGISTER(CRYPTO_RIJNDAEL128_CBC);
 	REGISTER(CRYPTO_DEFLATE_COMP);
+	REGISTER(CRYPTO_GZIP_COMP);
 #undef REGISTER
 }
Index: /trunk/src/sys/opencrypto/cryptosoft.h
===================================================================
--- /trunk/src/sys/opencrypto/cryptosoft.h	(revision 151)
+++ /trunk/src/sys/opencrypto/cryptosoft.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cryptosoft.h,v 1.5 2007/03/04 06:03:40 christos Exp $ */
+/*	$NetBSD: cryptosoft.h,v 1.5.60.1 2011/05/20 08:11:32 matt Exp $ */
 /*	$OpenBSD: cryptosoft.h,v 1.10 2002/04/22 23:10:09 deraadt Exp $	*/
 
@@ -42,4 +42,5 @@
 		struct {
 			u_int32_t	 SW_size;
+			u_int32_t	 SW_crc;
 			const struct swcr_comp_algo *SW_cxf;
 		} SWCR_COMP;
Index: /trunk/src/sys/opencrypto/cryptosoft_xform.c
===================================================================
--- /trunk/src/sys/opencrypto/cryptosoft_xform.c	(revision 151)
+++ /trunk/src/sys/opencrypto/cryptosoft_xform.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cryptosoft_xform.c,v 1.8 2008/02/04 00:35:34 tls Exp $ */
+/*	$NetBSD: cryptosoft_xform.c,v 1.8.26.1 2011/05/20 08:11:32 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/xform.c,v 1.1.2.1 2002/11/21 23:34:23 sam Exp $	*/
 /*	$OpenBSD: xform.c,v 1.19 2002/08/16 22:47:25 dhartmei Exp $	*/
@@ -41,5 +41,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(1, "$NetBSD: cryptosoft_xform.c,v 1.8 2008/02/04 00:35:34 tls Exp $");
+__KERNEL_RCSID(1, "$NetBSD: cryptosoft_xform.c,v 1.8.26.1 2011/05/20 08:11:32 matt Exp $");
 
 #include <crypto/blowfish/blowfish.h>
@@ -126,4 +126,6 @@
 static u_int32_t deflate_compress(u_int8_t *, u_int32_t, u_int8_t **);
 static u_int32_t deflate_decompress(u_int8_t *, u_int32_t, u_int8_t **);
+static u_int32_t gzip_compress(u_int8_t *, u_int32_t, u_int8_t **);
+static u_int32_t gzip_decompress(u_int8_t *, u_int32_t, u_int8_t **);
 
 /* Encryption instances */
@@ -277,4 +279,10 @@
 	deflate_compress,
 	deflate_decompress
+};
+
+static const struct swcr_comp_algo swcr_comp_algo_gzip = {
+	&comp_algo_deflate,
+	gzip_compress,
+	gzip_decompress
 };
 
@@ -645,2 +653,14 @@
 	return deflate_global(data, size, 1, out);
 }
+
+static u_int32_t
+gzip_compress(u_int8_t *data, u_int32_t size, u_int8_t **out)
+{
+	return gzip_global(data, size, 0, out);
+}
+
+static u_int32_t
+gzip_decompress(u_int8_t *data, u_int32_t size, u_int8_t **out)
+{
+	return gzip_global(data, size, 1, out);
+}
Index: /trunk/src/sys/opencrypto/deflate.c
===================================================================
--- /trunk/src/sys/opencrypto/deflate.c	(revision 151)
+++ /trunk/src/sys/opencrypto/deflate.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: deflate.c,v 1.11 2008/05/05 13:41:30 ad Exp $ */
+/*	$NetBSD: deflate.c,v 1.11.18.1 2011/05/20 08:11:32 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/deflate.c,v 1.1.2.1 2002/11/21 23:34:23 sam Exp $	*/
 /* $OpenBSD: deflate.c,v 1.3 2001/08/20 02:45:22 hugh Exp $ */
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: deflate.c,v 1.11 2008/05/05 13:41:30 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: deflate.c,v 1.11.18.1 2011/05/20 08:11:32 matt Exp $");
 
 #include <sys/types.h>
@@ -46,4 +46,5 @@
 #include <opencrypto/cryptodev.h>
 #include <opencrypto/deflate.h>
+
 
 int window_inflate = -1 * MAX_WBITS;
@@ -85,4 +86,6 @@
 	struct deflate_buf *buf, *tmp;
 	size_t len, old_len;
+
+	DPRINTF(("deflate_global: size %d\n", size));
 
 	len = ZBUF;
@@ -205,2 +208,262 @@
 	return 0;
 }
+
+/*
+ * Initial version will perform a single gzip encapsulation,
+ * filling in the header,
+ * and appending the crc and uncompressed length.
+ *
+ * Later version will support multiple buffers with 
+ * a flag indication final buffer.  The crc is maintained
+ * over all buffers and appended to the output along with 
+ * the uncompressed length after the final data buffer
+ * has been compressed and output.
+ *
+ * Ditto for uncompress - CRC is extracted from the final packed
+ * and compared against CRC of uncompressed data.
+ *
+ */
+
+/* constant header for the gzip */
+static const char gzip_header[10] = {
+	0x1f, 0x8b, 	/* ID1 ID2	*/
+	Z_DEFLATED, 	/* CM		*/
+	0,		/* FLG		*/
+	0, 0, 0, 0,	/* MTIME	*/
+	0,		/* XFL		*/
+	0x03		/* OS (Unix)	*/
+};
+
+/* Followed by compressed payload */
+/* Followed by uint32_t CRC32 and uint32_t ISIZE */
+#define GZIP_TAIL_SIZE	8
+
+u_int32_t
+gzip_global(u_int8_t *data, u_int32_t size,
+	int decomp, u_int8_t **out)
+{
+	/* decomp indicates whether we compress (0) or decompress (1) */
+	z_stream zbuf;
+	u_int8_t *output;
+	u_int32_t count, result;
+	int error, i = 0, j;
+	struct deflate_buf *buf, *tmp;
+	size_t nbufs, old_nbufs;
+	u_int32_t crc;
+	u_int32_t isize;
+
+	DPRINTF(("gzip_global: decomp %d, size %d\n", decomp, size));
+
+	nbufs = ZBUF;
+	buf = malloc(nbufs*sizeof(struct deflate_buf), M_CRYPTO_DATA, M_NOWAIT);
+	if (buf == NULL) {
+		DPRINTF(("gzip_global.%d: failed to malloc %d\n",
+				__LINE__, nbufs*sizeof(struct deflate_buf)));
+		return 0;
+	}
+
+	memset(&zbuf, 0, sizeof(z_stream));
+	for (j = 0; j < nbufs; j++)
+		buf[j].flag = 0;
+
+	zbuf.zalloc = ocf_zalloc;
+	zbuf.zfree = ocf_zfree;
+	zbuf.opaque = Z_NULL;
+
+	crc = crc32(0, NULL, 0);	/* get initial crc value */
+
+	zbuf.avail_in = size;	/* Total length of data to be processed */
+	zbuf.next_in = data;	/* data that is going to be processed */
+
+	if (!decomp) {
+		/* compress */
+		DPRINTF(("gzip_global: compress[%d] malloc %d + %d + %d = %d\n",
+				i, size, sizeof(gzip_header), GZIP_TAIL_SIZE,
+				size + sizeof(gzip_header) + GZIP_TAIL_SIZE));
+
+		buf[i].out = malloc(size, M_CRYPTO_DATA, M_NOWAIT);
+		if (buf[i].out == NULL)
+			goto bad2;
+		buf[i].size = size;
+		buf[i].flag = 1;
+
+		zbuf.next_out = buf[i].out;
+		zbuf.avail_out = buf[i].size;
+		i++;
+		
+		crc = crc32(crc, data, size);
+		DPRINTF(("gzip_compress: size %d, crc 0x%x\n", size, crc));
+	} else {
+		/* decompress */
+		/* check the gzip header */
+		if (zbuf.avail_in <= 0) {
+			/* Not enough data for the header & tail */
+			DPRINTF(("gzip_global: not enough data (%d)\n",
+					size));
+			goto bad2;
+		}
+
+		/* XXX this is pretty basic,
+		 * needs to be expanded to ignore MTIME, OS, 
+		 * but still ensure flags are 0.
+		 * Q. Do we need to support the flags and 
+		 * optional header fields? Likely.
+		 * XXX add flag and field support too.
+		 */
+		if (memcmp(data, gzip_header, sizeof(gzip_header)) != 0) {
+			DPRINTF(("gzip_global: unsupported gzip header (%02x%02x)\n",
+					data[0], data[1]));
+			goto bad2;
+		} else {
+			DPRINTF(("gzip_global.%d: gzip header ok\n",__LINE__));
+		}
+
+		isize = *((uint32_t *)&data[size-sizeof(uint32_t)]);
+
+		DPRINTF(("gzip_global: isize = %d (%02x %02x %02x %02x)\n",
+				isize,
+				data[size-4],
+				data[size-3],
+				data[size-2],
+				data[size-1]));
+
+		buf[i].size = isize;
+		buf[i].out = malloc(buf[i].size, M_CRYPTO_DATA, M_NOWAIT);
+		if (buf[i].out == NULL)
+			goto bad2;
+		buf[i].flag = 1;
+		zbuf.next_out = buf[i].out;
+		zbuf.avail_out = buf[i].size;
+		i++;
+
+		/* skip over the gzip header */
+		zbuf.next_in = data + sizeof(gzip_header);
+
+		/* actual payload size stripped of gzip header and tail */
+		zbuf.avail_in = size - sizeof(gzip_header) - GZIP_TAIL_SIZE;
+		DPRINTF(("zbuf avail_in %d, avail_out %d\n",
+					zbuf.avail_in, zbuf.avail_out));
+
+	}
+
+
+	error = decomp ? inflateInit2(&zbuf, window_inflate) :
+	    deflateInit2(&zbuf, Z_DEFAULT_COMPRESSION, Z_METHOD,
+		    window_deflate, Z_MEMLEVEL, Z_DEFAULT_STRATEGY);
+
+	if (error != Z_OK) {
+		printf("deflateInit2() failed\n");
+		goto bad;
+	}
+	for (;;) {
+		DPRINTF(("pre: %s in:%d out:%d\n", decomp ? "deflate()" : "inflate()", 
+				zbuf.avail_in, zbuf.avail_out));
+		error = decomp ? inflate(&zbuf, Z_PARTIAL_FLUSH) :
+				 deflate(&zbuf, Z_PARTIAL_FLUSH);
+		DPRINTF(("post: %s in:%d out:%d\n", decomp ? "deflate()" : "inflate()", 
+				zbuf.avail_in, zbuf.avail_out));
+		if (error != Z_OK && error != Z_STREAM_END) {
+			printf("deflate() or inflate() failed, error=%d\n", error);
+			goto bad;
+		} else if (zbuf.avail_in == 0 && zbuf.avail_out != 0) {
+			DPRINTF(("gzip_global: avail_in == 0, ending\n"));
+			goto end;
+		} else if (zbuf.avail_in == 0 && zbuf.avail_out == 0) {
+			DPRINTF(("gzip_global: avail_in == 0, avail_out == 0, ending\n"));
+			goto end;
+		} else if (zbuf.avail_out == 0) {
+			if (i == (nbufs-1)) {
+				old_nbufs = i;
+				nbufs += ZBUF;
+				tmp = realloc(buf,nbufs*sizeof(struct deflate_buf),
+							  M_CRYPTO_DATA, M_NOWAIT);
+				if (tmp == NULL)
+					goto bad;
+				buf = tmp;
+				for (j = old_nbufs; j < nbufs; j++)
+					buf[j].flag = 0;
+			}
+			/* we need more output space, allocate size */
+			buf[i].out = malloc(size, M_CRYPTO_DATA, M_NOWAIT);
+			if (buf[i].out == NULL)
+				goto bad;
+			zbuf.next_out = buf[i].out;
+			buf[i].size = size;
+			buf[i].flag = 1;
+			zbuf.avail_out = buf[i].size;
+			i++;
+		} else
+			goto bad;
+	}
+
+end:
+	if (decomp) {
+		count = result = zbuf.total_out;
+	} else {
+		/* need room for header, CRC, and ISIZE */
+		result = zbuf.total_out + sizeof(gzip_header) + GZIP_TAIL_SIZE;
+		count = zbuf.total_out;
+	}
+
+	DPRINTF(("gzip_global: in %d -> out %d\n", size, result));
+
+	*out = malloc(result, M_CRYPTO_DATA, M_NOWAIT);
+	if (*out == NULL)
+		goto bad;
+	output = *out;
+	if (decomp)
+		inflateEnd(&zbuf);
+	else {
+		deflateEnd(&zbuf);
+
+		/* fill in gzip header */
+		memcpy(output, gzip_header, sizeof(gzip_header));
+		output += sizeof(gzip_header);
+	}
+	for (j = 0; buf[j].flag != 0; j++) {
+		if (decomp) {
+			/* update crc for decompressed data */
+			crc = crc32(crc, buf[j].out, buf[j].size);
+		}
+		if (count > buf[j].size) {
+			memcpy(output, buf[j].out, buf[j].size);
+			output += buf[j].size;
+			free(buf[j].out, M_CRYPTO_DATA);
+			count -= buf[j].size;
+		} else {
+			/* it should be the last buffer */
+			memcpy(output, buf[j].out, count);
+			output += count;
+			free(buf[j].out, M_CRYPTO_DATA);
+			count = 0;
+		}
+	}
+	free(buf, M_CRYPTO_DATA);
+
+	if (!decomp) {
+		/* fill in CRC and ISIZE */
+		((uint32_t *)output)[0] = crc;
+		((uint32_t *)output)[1] = size;
+
+		DPRINTF(("gzip_global: size = 0x%x (%02x %02x %02x %02x)\n",
+				size,
+				output[7],
+				output[3],
+				output[5],
+				output[4]));
+	}
+
+	return result;
+
+bad:
+	if (decomp)
+		inflateEnd(&zbuf);
+	else
+		deflateEnd(&zbuf);
+bad2:
+	*out = NULL;
+	for (j = 0; buf[j].flag != 0; j++)
+		free(buf[j].out, M_CRYPTO_DATA);
+	free(buf, M_CRYPTO_DATA);
+	return 0;
+}
Index: /trunk/src/sys/opencrypto/deflate.h
===================================================================
--- /trunk/src/sys/opencrypto/deflate.h	(revision 151)
+++ /trunk/src/sys/opencrypto/deflate.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: deflate.h,v 1.5 2008/05/05 13:41:30 ad Exp $ */
+/*	$NetBSD: deflate.h,v 1.5.18.1 2011/05/20 08:11:32 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/deflate.h,v 1.1.2.1 2002/11/21 23:34:23 sam Exp $	*/
 /* $OpenBSD: deflate.h,v 1.3 2002/03/14 01:26:51 millert Exp $ */
@@ -46,4 +46,5 @@
 
 u_int32_t deflate_global(u_int8_t *, u_int32_t, int, u_int8_t **);
+u_int32_t gzip_global(u_int8_t *, u_int32_t, int, u_int8_t **);
 void *z_alloc(void *, u_int, u_int);
 void z_free(void *, void *);
Index: /trunk/src/sys/opencrypto/files.opencrypto
===================================================================
--- /trunk/src/sys/opencrypto/files.opencrypto	(revision 151)
+++ /trunk/src/sys/opencrypto/files.opencrypto	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: files.opencrypto,v 1.19 2008/02/04 00:35:35 tls Exp $
+#	$NetBSD: files.opencrypto,v 1.19.28.1 2011/05/20 08:11:32 matt Exp $
 #
 #
@@ -24,4 +24,5 @@
 defpseudo crypto: opencrypto
 file	opencrypto/cryptodev.c		crypto
+file	opencrypto/ocryptodev.c		crypto
 
 defflag opt_ocf.h	CRYPTO_DEBUG CRYPTO_TIMING
Index: /trunk/src/sys/opencrypto/ocryptodev.c
===================================================================
--- /trunk/src/sys/opencrypto/ocryptodev.c	(revision 151)
+++ /trunk/src/sys/opencrypto/ocryptodev.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: ocryptodev.c,v 1.2.4.2 2009/05/03 17:24:45 snj Exp $ */
+/*	$NetBSD: ocryptodev.c,v 1.4.2.2 2011/05/20 08:11:32 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/cryptodev.c,v 1.4.2.4 2003/06/03 00:09:02 sam Exp $	*/
 /*	$OpenBSD: cryptodev.c,v 1.53 2002/07/10 22:21:30 mickey Exp $	*/
@@ -70,5 +70,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: ocryptodev.c,v 1.2.4.2 2009/05/03 17:24:45 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: ocryptodev.c,v 1.4.2.2 2011/05/20 08:11:32 matt Exp $");
 
 #include <sys/param.h>
Index: /trunk/src/sys/opencrypto/ocryptodev.h
===================================================================
--- /trunk/src/sys/opencrypto/ocryptodev.h	(revision 151)
+++ /trunk/src/sys/opencrypto/ocryptodev.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: ocryptodev.h,v 1.1.4.2 2009/05/03 17:24:45 snj Exp $ */
+/*	$NetBSD: ocryptodev.h,v 1.2.2.2 2011/05/20 08:11:33 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/cryptodev.h,v 1.2.2.6 2003/07/02 17:04:50 sam Exp $	*/
 /*	$OpenBSD: cryptodev.h,v 1.33 2002/07/17 23:52:39 art Exp $	*/
Index: /trunk/src/sys/opencrypto/xform.c
===================================================================
--- /trunk/src/sys/opencrypto/xform.c	(revision 151)
+++ /trunk/src/sys/opencrypto/xform.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: xform.c,v 1.17 2008/02/28 09:29:10 tls Exp $ */
+/*	$NetBSD: xform.c,v 1.17.22.1 2011/05/20 08:11:33 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/xform.c,v 1.1.2.1 2002/11/21 23:34:23 sam Exp $	*/
 /*	$OpenBSD: xform.c,v 1.19 2002/08/16 22:47:25 dhartmei Exp $	*/
@@ -41,5 +41,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: xform.c,v 1.17 2008/02/28 09:29:10 tls Exp $");
+__KERNEL_RCSID(0, "$NetBSD: xform.c,v 1.17.22.1 2011/05/20 08:11:33 matt Exp $");
 
 #include <sys/param.h>
@@ -191,2 +191,7 @@
 	90
 };
+
+struct comp_algo comp_algo_gzip = {
+	CRYPTO_GZIP_COMP, "GZIP",
+	90
+};
Index: /trunk/src/sys/opencrypto/xform.h
===================================================================
--- /trunk/src/sys/opencrypto/xform.h	(revision 151)
+++ /trunk/src/sys/opencrypto/xform.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: xform.h,v 1.9 2008/02/02 02:39:01 tls Exp $ */
+/*	$NetBSD: xform.h,v 1.9.28.1 2011/05/20 08:11:33 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/xform.h,v 1.1.2.1 2002/11/21 23:34:23 sam Exp $	*/
 /*	$OpenBSD: xform.h,v 1.10 2002/04/22 23:10:09 deraadt Exp $	*/
@@ -86,4 +86,5 @@
 
 extern struct comp_algo comp_algo_deflate;
+extern struct comp_algo comp_algo_gzip;
 
 #ifdef _KERNEL
Index: /trunk/src/sys/sys/Makefile
===================================================================
--- /trunk/src/sys/sys/Makefile	(revision 151)
+++ /trunk/src/sys/sys/Makefile	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: Makefile,v 1.114 2008/10/19 22:05:23 apb Exp $
+#	$NetBSD: Makefile,v 1.114.8.1 2011/04/29 08:11:22 matt Exp $
 
 .include <bsd.sys.mk>
@@ -34,5 +34,5 @@
 	syncobj.h syslimits.h syslog.h \
 	tape.h termios.h time.h timeb.h timepps.h times.h \
-	timex.h trace.h tree.h tty.h ttychars.h ttycom.h \
+	timex.h tls.h trace.h tree.h tty.h ttychars.h ttycom.h \
 	ttydefaults.h ttydev.h types.h \
 	ucontext.h ucred.h uio.h un.h unistd.h unpcb.h user.h utsname.h uuid.h \
Index: /trunk/src/sys/sys/cdefs.h
===================================================================
--- /trunk/src/sys/sys/cdefs.h	(revision 151)
+++ /trunk/src/sys/sys/cdefs.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cdefs.h,v 1.69 2008/08/17 00:23:02 gmcgarry Exp $	*/
+/*	$NetBSD: cdefs.h,v 1.69.10.1 2011/04/29 08:10:38 matt Exp $	*/
 
 /*
@@ -135,4 +135,15 @@
 #define	__aconst
 #endif
+
+/*
+ * Compile Time Assertion.
+ */
+#ifdef __COUNTER__
+#define	__CTASSERT(x)		__CTASSERT0(x, __ctassert, __COUNTER__)
+#else
+#define	__CTASSERT(x)		__CTASSERT0(x, __ctassert, __LINE__)
+#endif
+#define	__CTASSERT0(x, y, z)	__CTASSERT1(x, y, z)
+#define	__CTASSERT1(x, y, z)	typedef char y ## z[(x) ? 1 : -1];
 
 /*
Index: /trunk/src/sys/sys/cpu.h
===================================================================
--- /trunk/src/sys/sys/cpu.h	(revision 151)
+++ /trunk/src/sys/sys/cpu.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cpu.h,v 1.23.4.3 2009/02/02 03:19:32 snj Exp $	*/
+/*	$NetBSD: cpu.h,v 1.23.4.3.4.1 2011/04/29 08:20:15 matt Exp $	*/
 
 /*-
@@ -76,4 +76,5 @@
 void	cpu_kpreempt_exit(uintptr_t);
 bool	cpu_kpreempt_disabled(void);
+int	cpu_lwp_setprivate(struct lwp *, void *);
 
 CIRCLEQ_HEAD(cpuqueue, cpu_info);
Index: /trunk/src/sys/sys/cpu_data.h
===================================================================
--- /trunk/src/sys/sys/cpu_data.h	(revision 151)
+++ /trunk/src/sys/sys/cpu_data.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cpu_data.h,v 1.27.16.1 2010/05/09 20:25:45 rmind Exp $	*/
+/*	cpu_data.h,v 1.27.16.2 2011/04/29 08:13:53 matt Exp	*/
 
 /*-
@@ -72,5 +72,5 @@
 	CIRCLEQ_ENTRY(cpu_info) cpu_qchain;	/* circleq of all CPUs */
 
-	cpuid_t		cpu_node_id;
+	cpuid_t		cpu_package_id;
 	cpuid_t		cpu_core_id;
 	cpuid_t		cpu_smt_id;
@@ -114,5 +114,5 @@
 #define	ci_lkdebug_recurse	ci_data.cpu_lkdebug_recurse
 
-#define	ci_node_id		ci_data.cpu_node_id
+#define	ci_package_id		ci_data.cpu_package_id
 #define	ci_core_id		ci_data.cpu_core_id
 #define	ci_smt_id		ci_data.cpu_smt_id
Index: /trunk/src/sys/sys/lwp.h
===================================================================
--- /trunk/src/sys/sys/lwp.h	(revision 151)
+++ /trunk/src/sys/sys/lwp.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: lwp.h,v 1.114.4.1 2009/02/06 01:54:09 snj Exp $	*/
+/*	$NetBSD: lwp.h,v 1.114.4.1.4.3 2011/04/29 08:20:15 matt Exp $	*/
 
 /*-
@@ -32,4 +32,8 @@
 #ifndef _SYS_LWP_H_
 #define _SYS_LWP_H_
+
+#ifdef _KERNEL_OPT
+#include "opt_multiprocessor.h"
+#endif
 
 #include <sys/time.h>
@@ -200,4 +204,11 @@
 
 extern lwp_t lwp0;			/* LWP for proc0 */
+
+static inline void *
+lwp_getpcb(lwp_t *l)
+{
+
+	return l->l_addr;
+}
 #endif
 
@@ -308,4 +319,5 @@
 void	lwp_need_userret(lwp_t *);
 void	lwp_free(lwp_t *, bool, bool);
+int	lwp_setprivate(lwp_t *, void *);
 void	lwp_sys_init(void);
 u_int	lwp_unsleep(lwp_t *, bool);
Index: /trunk/src/sys/sys/param.h
===================================================================
--- /trunk/src/sys/sys/param.h	(revision 151)
+++ /trunk/src/sys/sys/param.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: param.h,v 1.330.4.9.2.2.2.1 2010/04/21 00:28:24 matt Exp $	*/
+/*	param.h,v 1.330.4.9.2.2.2.1 2010/04/21 00:28:24 matt Exp	*/
 
 /*-
@@ -64,5 +64,5 @@
  */
 
-#define	__NetBSD_Version__	500000003	/* NetBSD 5.0_STABLE */
+#define	__NetBSD_Version__	501000000	/* NetBSD 5.1 */
 
 #define __NetBSD_Prereq__(M,m,p) (((((M) * 100000000) + \
Index: /trunk/src/sys/sys/socketvar.h
===================================================================
--- /trunk/src/sys/sys/socketvar.h	(revision 151)
+++ /trunk/src/sys/sys/socketvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: socketvar.h,v 1.116.4.2 2009/04/04 23:36:28 snj Exp $	*/
+/*	socketvar.h,v 1.116.4.2 2009/04/04 23:36:28 snj Exp	*/
 
 /*-
@@ -506,5 +506,5 @@
 
 /* sosend loan */
-vaddr_t	sokvaalloc(vsize_t, struct socket *);
+vaddr_t	sokvaalloc(vaddr_t, vsize_t, struct socket *);
 void	sokvafree(vaddr_t, vsize_t);
 void	soloanfree(struct mbuf *, void *, size_t, void *);
Index: /trunk/src/sys/sys/tls.h
===================================================================
--- /trunk/src/sys/sys/tls.h	(revision 152)
+++ /trunk/src/sys/sys/tls.h	(revision 152)
@@ -0,0 +1,61 @@
+/*	$NetBSD: tls.h,v 1.1.4.2 2011/04/29 07:43:19 matt Exp $	*/
+/*-
+ * Copyright (c) 2011 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Joerg Sonnenberger.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _SYS_TLS_H_
+#define _SYS_TLS_H_
+
+#include <sys/cdefs.h>
+#include <machine/types.h>
+
+#if defined(__HAVE_TLS_VARIANT_I) || defined(__HAVE_TLS_VARIANT_II)
+
+#if defined(__HAVE_TLS_VARIANT_I) && defined(__HAVE_TLS_VARIANT_II)
+#error Only one TLS variant can be supported at a time
+#endif
+
+struct tls_tcb {
+#ifdef __HAVE_TLS_VARIANT_I
+	void	**tcb_dtv;
+	void	*tcb_pthread;
+#else
+	void	*tcb_self;
+	void	**tcb_dtv;
+	void	*tcb_pthread;
+#endif
+};
+
+__BEGIN_DECLS
+struct tls_tcb	*_rtld_tls_allocate(void);
+void	 	 _rtld_tls_free(struct tls_tcb *);
+void		 _rtld_tls_static_setup(void);
+__END_DECLS
+#endif /* __HAVE_TLS_VARIANT_I || __HAVE_TLS_VARIANT_II */
+
+#endif /* _SYS_TLS_H_ */
Index: /trunk/src/sys/sys/ucontext.h
===================================================================
--- /trunk/src/sys/sys/ucontext.h	(revision 151)
+++ /trunk/src/sys/sys/ucontext.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: ucontext.h,v 1.11 2008/10/15 06:51:21 wrstuden Exp $	*/
+/*	$NetBSD: ucontext.h,v 1.11.12.1 2011/04/29 08:14:36 matt Exp $	*/
 
 /*-
@@ -58,7 +58,27 @@
 #define _UC_CPU		0x04		/* valid GPR context in uc_mcontext */
 #define _UC_FPU		0x08		/* valid FPU context in uc_mcontext */
+#define	_UC_MD		0x40070020	/* MD bits.  see below */
+
+/*
+ * _UC_MD includes:
+ *	_UC_SETSTACK	0x00010000 (many ports) and 0x00020000 (arm)
+ *	_UC_CLRSTACK	0x00020000 (many ports) and 0x00040000 (arm)
+ *	_UC_POWERPC_VEC	0x00010000 (powerpc)
+ *	_UC_M68K_UC_USER 0x40000000 (m68k)
+ *	_UC_UNIQUE	0x00000020 (alpha)
+ *	_UC_ARM_VFP	0x00010000 (arm)
+ *	_UC_VM		0x00040000 (i386)
+ *	_UC_FXSAVE	0x00000020 (i386)
+ *
+ * if your port needs more MD bits, please try to choose bits from _UC_MD
+ * first, rather than picking random unused bits.
+ */
 
 #ifdef _KERNEL
 struct lwp;
+
+#ifdef __UCONTEXT_SIZE
+__CTASSERT(sizeof(ucontext_t) == __UCONTEXT_SIZE)
+#endif
 
 void	getucontext(struct lwp *, ucontext_t *);
Index: /trunk/src/sys/ufs/ufs/ufs_inode.c
===================================================================
--- /trunk/src/sys/ufs/ufs/ufs_inode.c	(revision 151)
+++ /trunk/src/sys/ufs/ufs/ufs_inode.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: ufs_inode.c,v 1.76.4.1.4.1 2010/04/21 00:28:26 matt Exp $	*/
+/*	$NetBSD: ufs_inode.c,v 1.76.4.1.4.2 2011/05/20 08:11:33 matt Exp $	*/
 
 /*
@@ -38,5 +38,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: ufs_inode.c,v 1.76.4.1.4.1 2010/04/21 00:28:26 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: ufs_inode.c,v 1.76.4.1.4.2 2011/05/20 08:11:33 matt Exp $");
 
 #if defined(_KERNEL_OPT)
@@ -276,9 +276,9 @@
 	len += delta;
 
- retry:
+	genfs_node_wrlock(vp);
 	mutex_enter(&uobj->vmobjlock);
 	error = VOP_GETPAGES(vp, pagestart, pgs, &npages, 0,
-	    VM_PROT_WRITE, 0,
-	    PGO_SYNCIO|PGO_PASTEOF|PGO_NOBLOCKALLOC|PGO_NOTIMESTAMP);
+	    VM_PROT_WRITE, 0, PGO_SYNCIO | PGO_PASTEOF | PGO_NOBLOCKALLOC |
+	    PGO_NOTIMESTAMP | PGO_GLOCKHELD);
 	if (error) {
 		goto out;
@@ -298,23 +298,4 @@
 	 * now allocate the range.
 	 */
-
-	/*
-	 * XXX: Hack around deadlock with pagebusy and genfs node lock.
-	 *      This should be properly fixed.  PR kern/40389
-	 */
-	{
-	struct genfs_node *gp = VTOG(vp); /* XXX */
-
-	if (!rw_tryenter(&gp->g_glock, RW_WRITER)) {
-		mutex_enter(&uobj->vmobjlock);
-		for (i = 0; i < npages; i++)
-			pgs[i]->flags |= PG_RELEASED | PG_CLEAN;
-		mutex_enter(&uvm_pageqlock);
-		uvm_page_unbusy(pgs, npages);
-		mutex_exit(&uvm_pageqlock);
-		mutex_exit(&uobj->vmobjlock);
-		kpause("uballo", false, 1, NULL);
-		goto retry;
-	}}
 
 	error = GOP_ALLOC(vp, off, len, flags, cred);
Index: /trunk/src/sys/uvm/uvm_aobj.c
===================================================================
--- /trunk/src/sys/uvm/uvm_aobj.c	(revision 151)
+++ /trunk/src/sys/uvm/uvm_aobj.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_aobj.c,v 1.104 2008/10/18 03:46:22 rmind Exp $	*/
+/*	uvm_aobj.c,v 1.104 2008/10/18 03:46:22 rmind Exp	*/
 
 /*
@@ -44,5 +44,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: uvm_aobj.c,v 1.104 2008/10/18 03:46:22 rmind Exp $");
+__KERNEL_RCSID(0, "uvm_aobj.c,v 1.104 2008/10/18 03:46:22 rmind Exp");
 
 #include "opt_uvmhist.h"
@@ -977,5 +977,5 @@
 			    current_offset >> PAGE_SHIFT) == 0) {
 				ptmp = uvm_pagealloc(uobj, current_offset,
-				    NULL, UVM_PGA_ZERO);
+				    NULL, UVM_FLAG_COLORMATCH|UVM_PGA_ZERO);
 				if (ptmp) {
 					/* new page */
Index: /trunk/src/sys/uvm/uvm_extern.h
===================================================================
--- /trunk/src/sys/uvm/uvm_extern.h	(revision 151)
+++ /trunk/src/sys/uvm/uvm_extern.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_extern.h,v 1.148.4.2.4.1 2010/01/26 21:26:28 matt Exp $	*/
+/*	uvm_extern.h,v 1.148.4.2.4.1 2010/01/26 21:26:28 matt Exp	*/
 
 /*
@@ -174,4 +174,5 @@
 #define UVM_KMF_NOWAIT	UVM_FLAG_NOWAIT		/* not allowed to sleep */
 #define UVM_KMF_WAITVA	UVM_FLAG_WAITVA		/* sleep for va */
+#define	UVM_KMF_COLORMATCH UVM_FLAG_COLORMATCH	/* start at color in align */
 
 /*
Index: /trunk/src/sys/uvm/uvm_fault.c
===================================================================
--- /trunk/src/sys/uvm/uvm_fault.c	(revision 151)
+++ /trunk/src/sys/uvm/uvm_fault.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_fault.c,v 1.125.6.1.4.1 2010/01/26 21:26:28 matt Exp $	*/
+/*	uvm_fault.c,v 1.125.6.1.4.1 2010/01/26 21:26:28 matt Exp	*/
 
 /*
@@ -40,5 +40,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: uvm_fault.c,v 1.125.6.1.4.1 2010/01/26 21:26:28 matt Exp $");
+__KERNEL_RCSID(0, "uvm_fault.c,v 1.125.6.1.4.1 2010/01/26 21:26:28 matt Exp");
 
 #include "opt_uvmhist.h"
@@ -362,5 +362,5 @@
 			 * no page, we must try and bring it in.
 			 */
-
+			KASSERT(ufi != NULL);
 			pg = uvm_pagealloc(NULL, ufi->orig_rvaddr,
 			    NULL, UVM_FLAG_COLORMATCH);
Index: /trunk/src/sys/uvm/uvm_km.c
===================================================================
--- /trunk/src/sys/uvm/uvm_km.c	(revision 151)
+++ /trunk/src/sys/uvm/uvm_km.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_km.c,v 1.101.4.2.4.3 2010/02/06 05:28:30 matt Exp $	*/
+/*	uvm_km.c,v 1.101.4.2.4.3 2010/02/06 05:28:30 matt Exp	*/
 
 /*
@@ -129,5 +129,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: uvm_km.c,v 1.101.4.2.4.3 2010/02/06 05:28:30 matt Exp $");
+__KERNEL_RCSID(0, "uvm_km.c,v 1.101.4.2.4.3 2010/02/06 05:28:30 matt Exp");
 
 #include "opt_uvmhist.h"
@@ -542,4 +542,6 @@
 		(flags & UVM_KMF_TYPEMASK) == UVM_KMF_PAGEABLE ||
 		(flags & UVM_KMF_TYPEMASK) == UVM_KMF_VAONLY);
+	KASSERT((flags & UVM_KMF_VAONLY) != 0 || (flags & UVM_KMF_COLORMATCH) == 0);
+	KASSERT((flags & UVM_KMF_COLORMATCH) == 0 || (flags & UVM_KMF_VAONLY) != 0);
 
 	/*
@@ -560,5 +562,5 @@
 	    align, UVM_MAPFLAG(UVM_PROT_ALL, UVM_PROT_ALL, UVM_INH_NONE,
 	    UVM_ADV_RANDOM,
-	    (flags & (UVM_KMF_TRYLOCK | UVM_KMF_NOWAIT | UVM_KMF_WAITVA))
+	    (flags & (UVM_KMF_TRYLOCK | UVM_KMF_NOWAIT | UVM_KMF_WAITVA | UVM_KMF_COLORMATCH))
 	    | UVM_FLAG_QUANTUM)) != 0)) {
 		UVMHIST_LOG(maphist, "<- done (no VM)",0,0,0,0);
